SoMaterialBinding Class Reference
Node Classes

The SoMaterialBinding class is a node for setting up how materials are mapped to shapes. More...

`#include <Inventor/nodes/SoMaterialBinding.h>`

Inheritance diagram for SoMaterialBinding:

## Public Types

enum

Binding {
OVERALL = SoMaterialBindingElement::OVERALL , PER_PART = SoMaterialBindingElement::PER_PART , PER_PART_INDEXED = SoMaterialBindingElement::PER_PART_INDEXED , PER_FACE = SoMaterialBindingElement::PER_FACE ,
PER_FACE_INDEXED = SoMaterialBindingElement::PER_FACE_INDEXED , PER_VERTEX = SoMaterialBindingElement::PER_VERTEX , PER_VERTEX_INDEXED = SoMaterialBindingElement::PER_VERTEX_INDEXED , DEFAULT = OVERALL ,
NONE = OVERALL
}

Public Types inherited from SoNode

enum

NodeType {
INVENTOR = 0x0000 , VRML1 = 0x0001 , VRML2 = 0x0002 , INVENTOR_1 = 0x0004 ,
INVENTOR_2_0 = 0x0008 , INVENTOR_2_1 = 0x0010 , INVENTOR_2_5 = 0x0020 , INVENTOR_2_6 = 0x0040 ,
COIN_1_0 = 0x0080 , COIN_2_0 = 0x0100 , EXTENSION = 0x0200 , COIN_2_2 = 0x0400 ,
COIN_2_3 = 0x0800 , COIN_2_4 = 0x1000 , INVENTOR_5_0 = 0x2000 , COIN_2_5 = 0x4000 ,
COIN_3_0 = 0x8000 , INVENTOR_6_0 = 0x10000 , COIN_4_0 = 0x20000
}

## Public Member Functions

virtual SoType | getTypeId (void) const
| SoMaterialBinding (void)
virtual void | doAction (SoAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | pick (SoPickAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual SbBool | affectsState (void) const
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | search (SoSearchAction *action)
virtual void | write (SoWriteAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
virtual void | startNotify (void)
virtual void | notify (SoNotList *l)
SbUniqueId | getNodeId (void) const
virtual SoChildList * | getChildren (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoNode * | addToCopyDict (void) const
virtual void | copyContents (const SoFieldContainer *from, SbBool copyconnections)
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
| Returns `TRUE` if the type of this object is either of the same type or inherited from type.
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions

static SoType | getClassTypeId (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | initClasses (void)
static SbUniqueId | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Public Attributes

SoSFEnum | value

## Protected Member Functions

virtual const SoFieldData * | getFieldData (void) const
virtual | ~SoMaterialBinding ()
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const
virtual SoNotRec | createNotRec (void)

## Static Protected Member Functions

static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Additional Inherited Members

Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01 , IS_GROUP = 0x02 }
Protected Attributes inherited from SoNode
SbUniqueId | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn
Static Protected Attributes inherited from SoNode
static SbUniqueId | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoMaterialBinding class is a node for setting up how materials are mapped to shapes.

The material binding specified in nodes of this type decides how the material values of SoMaterial nodes are mapped on the built-in geometry shape nodes.

The exact meaning of a binding depends on what particular shape type a material or a set of materials are applied to.

Here is a very simple usage example:

    #Inventor V2.1 ascii

    Separator {
       Coordinate3 {
          point [ 0 0 0, 1 0 0, 1 1 0 ]
       }

       Material {
          diffuseColor [ 1 0 0, 1 1 0, 0 0 1 ]
       }

       MaterialBinding {
          value PER_VERTEX_INDEXED
       }

       IndexedFaceSet {
          coordIndex [ 0, 1, 2, -1 ]
          materialIndex [ 0, 1, 0 ]
       }
    }

With SoMaterialBinding::value set to `PER_VERTEX_INDEXED` above, the material indices will be taken from the SoIndexedFaceSet::materialIndex field when rendering.

If SoMaterialBinding::value was set to `PER_VERTEX_INDEXED` as above, and the SoIndexedFaceSet::materialIndex was undefined or empty, indices would implicitly be taken from the SoIndexedFaceSet::coordIndex field.

If SoMaterialBinding::value is set to `PER_VERTEX`, colors will be fetched in a monotonically increasing manner from the SoMaterial::diffuseColor field, starting at index 0.

FILE FORMAT/DEFAULTS:

MaterialBinding {
value OVERALL
}
SoMaterialBinding::value
SoSFEnum value
Definition SoMaterialBinding.h:64
SoMaterialBinding::OVERALL
@ OVERALL
Definition SoMaterialBinding.h:50

See also
  SoMaterial

## Member Enumeration Documentation

## Binding

enum SoMaterialBinding::Binding

Enumeration of available types of material binding.

Enumerator
OVERALL | Apply the same material to the complete shape.

PER_PART

Get a new material from the pool of material values for each part of the shape, where the definition of a part depends on the shape type.

Materials are fetched from index 0 and onwards, incrementing the index into the material pool by 1 for each new part in the order defined by the particular shape type.

Important portability note: it was previously allowed with the SGI Inventor library to supply too few colors versus the number of parts of the subsequent shapes in the scene graph. Coloring would then cycle through the available colors.

Since SGI Open Inventor v2.1, this was disallowed, though – enough colors for all parts must be supplied, or behavior will be unspecified (likely to cause a crash, in fact). Note that the «Inventor Mentor» book contains a description of the old, invalid behavior in Chapter 5, section "Binding Nodes" (middle of page 128 in the 10th printing).

PER_PART_INDEXED | Get a new material from the pool of material values for each part of the shape, where the definition of a part depends on the shape type. Materials are fetched by the index value settings of the shape.

PER_FACE

Get a new material from the pool of material values for each polygon face of the shape.

Materials are fetched from index 0 and onwards, incrementing the index into the material pool by 1 for each new face of the shape node.

Note that individual faces after tessellation of complex shapes (like SoCylinder nodes) are not considered to be separate entities, and so this binding will be treated in the same manner as SoMaterialBinding::PER_PART for those.

PER_FACE_INDEXED

Get a new material from the pool of material values for each polygon face of the shape.

Materials are fetched by the index value settings of the shape.

Note that individual faces after tessellation of complex shapes (like SoCylinder nodes) are not considered to be separate entities, and so this binding will be treated in the same manner as SoMaterialBinding::PER_PART_INDEXED for those.

PER_VERTEX | Get a new material from the pool of material values for each polygon, line or point vertex of the shape. Materials are fetched from index 0 and onwards, incrementing the index into the material pool by 1 for each new vertex of the shape node.
PER_VERTEX_INDEXED | Get a new material from the pool of material values for each polygon, line or point vertex of the shape. Materials are fetched by the index value settings of the shape.
DEFAULT | Obsolete. Don't use this value.
NONE | Obsolete. Don't use this value.

## Constructor & Destructor Documentation

## SoMaterialBinding()

SoMaterialBinding::SoMaterialBinding | ( | void |  | ) |

Constructor.

## ~SoMaterialBinding()

SoMaterialBinding::~SoMaterialBinding | ( |  | ) |

protected virtual

Destructor.

## Member Function Documentation

## getClassTypeId()

SoType SoMaterialBinding::getClassTypeId | ( | void |  | ) |

static

This static method returns the SoType object associated with objects of this class.

## getTypeId()

SoType SoMaterialBinding::getTypeId | ( | void |  | ) | const

virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.

Implements SoBase.

## getFieldDataPtr()

const SoFieldData ** SoMaterialBinding::getFieldDataPtr | ( | void |  | ) |

static protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Returns the SoFieldData class which holds information about fields in this node.

## getFieldData()

const SoFieldData * SoMaterialBinding::getFieldData | ( | void |  | ) | const

protected virtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoFieldContainer.

## doAction()

void SoMaterialBinding::doAction | ( | SoAction * | action | ) |

virtual

This function performs the typical operation of a node for any action.

Reimplemented from SoNode.

## GLRender()

void SoMaterialBinding::GLRender | ( | SoGLRenderAction * | action | ) |

virtual

Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoNode.

## callback()

void SoMaterialBinding::callback | ( | SoCallbackAction * | action | ) |

virtual

Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoNode.

## pick()

void SoMaterialBinding::pick | ( | SoPickAction * | action | ) |

virtual

Action method for SoPickAction.

Does common processing for SoPickAction action instances.

Reimplemented from SoNode.

## getPrimitiveCount()

void SoMaterialBinding::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) |

virtual

Action method for the SoGetPrimitiveCountAction.

Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action.

Nodes influencing how geometry nodes calculate their primitive count also override this method to change the relevant state variables.

Reimplemented from SoNode.

## Member Data Documentation

## value

SoSFEnum SoMaterialBinding::value

The material binding to use for subsequent shape nodes in the scene graph. The default binding is SoMaterialBinding::OVERALL.

The documentation for this class was generated from the following files:

- SoMaterialBinding.h
- SoMaterialBinding.cpp